// 08/27/2014 -  George Thomas, W5JDX - www.amateurlogic.tv  -  RigPwrRelaySwitchServo.ino
// 12vdc SPDT relay, coil connected to ACC port pin 7 and ground of IC-7700. 
// Relay energized when rig is on, servo turns antenna switch to ON position.
// When rig power is off relay drops and servo turns antenna switch to OFF position.

// declare some parameters and variables
#include <Servo.h>    // use the Servo library
Servo SwitchServo;    // create servo object to control a servo 
int button1 = 4;      // buttons are relay contacts, button1 turns antenna switch to ON position
int button2 = 6;      // buttons are relay contacts, button2 turns antenna switch to OFF position
int button1State = 0; // variable to hold state of the ON button (relay N/O contact)
int button2State = 0; // variable to hold state of the OFF button(relay N/C contact)
int onPosition = 80;  // servo position for switch on. Decrease number to increase travel (installation specific)
int offPosition = 144;// servo position for switch off. Increase number to increase travel(installation specific)

void setup()                // executes when Arduino powers up
{ 
  pinMode(button1, INPUT);  // set direction of digital I/O pins
  pinMode(button2, INPUT);
  Serial.begin(9600);       // open port for debug read val from serial port
} 
 
void loop()                 // executes continuously when Arduino is powered up
{ 
  int pos =  SwitchServo.read();                    //last position sent to servo
  Serial.println(pos);                              //display position
  button1State = digitalRead(button1);              //read button (relay N/O) input
  if (button1State == HIGH && pos != onPosition)   //if relay energized and switch is in OFF position.
  {                                                 //turn switch to ON positon.
    SwitchServo.attach(9);                          //attache the servo on pin 9 to the servo object 
    SwitchServo.write(onPosition);                 //set the servo position to turn antenna switch ON
    delay(1000);                                    //wait 1 second
    SwitchServo.detach();                           //antenna switch can maintain it's position so release servo
    Serial.println("button 1 high, Antenna Switch ON");//display button(relay) status
  }

  button2State = digitalRead(button2);              //read button (relay N/C) input
  if (button2State == HIGH && pos != offPosition)    //if relay deenergized and switch is in ON position.    
  {                                                 //turn switch to OFF positon.
    SwitchServo.attach(9);  
    SwitchServo.write(offPosition);                  //set the servo position to turn antenna switch ON 
    delay(1000);
    SwitchServo.detach();
    Serial.println("button 2 high, Antenna Switch OFF");
  }
  delay(15);                                        //just a 15 ms delay before repeating
} 
